/* stepper_motor.c
 *
 * Created: 9/8/2022 8:57:58 AM
 *  Author: Aaron
 *
 *	This file contains functions necessary to 
 *	control stepper motors using Full Wave Mode.
 */ 


#define F_CPU 16000000UL
//inclusions 
#include <avr/io.h>
#include <util/delay.h> 
#include "stepper_motor.h"

//stepper motor array definitions
uint8_t full[4] = {0x03,0x06,0x0C,0x09};
uint8_t fullr[4] = {0x09,0x0C,0x06,0x03};
	


//function drive stepper motor to specific degree selected
void Stepper_Position(uint32_t degrees)
{
	//determine how many steps is needed to rotate given degrees
  	uint32_t steps = (degrees * 512)/360;  
	  
	 	for(uint32_t i =0; i < steps; i++)		//loop through array # of times
	 	{
		 	for(uint16_t j=0; j < 4; j++)		//loop through the whole array
		 	{
			 	Stepper_Output = full[j];
			 	_delay_ms(3);
		 	}
	 	}
}

void Stepper_PositionR(uint32_t degrees)
{
	//determine how many steps is needed to rotate given degrees
	uint32_t steps = (degrees * 512)/360;
	
	for(uint32_t i =0; i < steps; i++)		//loop through array # of times
	{
		for(uint16_t j=0; j < 4; j++)		//loop through the whole array
		{
			Stepper_Output = fullr[j];
			_delay_ms(3);
		}
	}
	
}